-- By D4KiR

D4_HUD = D4_HUD or {}

AB_BR = 6

AB_W = ActionButton1:GetWidth()
ABAR_W = ActionButton1:GetWidth() * 18 + AB_BR * 17

local tab = {}
tab.w = 20
tab.h = 20
tab.x = -ABAR_W / 2 - 34 + AB_BR
tab.y = 0
tab.align = "BOTTOM"
tab.text = GetActionBarPage()
tab.textalign = "CENTER"
tab.textsize = 13
tab.color = {}
tab.color.a = 0
local PageNumber = createF(tab)

local coords = {}
coords.w = 20
coords.h = 20
coords.x = -74
coords.y = -176
coords.align = "TOPRIGHT"
coords.text = "LOAD"
coords.textalign = "CENTER"
coords.textsize = 10
coords.color = {}
coords.color.a = 0
local Coords = createF(coords)

ABS = ABS or {}

local dbloaded = false
local setup = false
function Setup()
	if not setup then
		setup = true
		print("|c008888ffSetup " .. D4_HUD.name)



		--
		EPBar = CreateBar({})
		local exhaustion = {}
		exhaustion.parent = EPBar.background
		exhaustion.align = "LEFT"
		exhaustion.color = {}
		exhaustion.color.r = 0.4
		exhaustion.color.g = 0.2
		exhaustion.color.b = 0.9
		exhaustion.color.a = 0.99
		exhaustion.text = ""
		exhaustion.texture = "Interface/TargetingFrame/UI-StatusBar"
		exhaustion.autoresize = true
		EPBar.exhaustion = createF(exhaustion)
		exhaustion.autoresize = false

		local azbar = {}
		azbar.barcolor = {}
		azbar.barcolor.r = RGBToDec(167)
		azbar.barcolor.g = RGBToDec(148)
		azbar.barcolor.b = RGBToDec(116)
		azbar.barcolor.a = RGBToDec(255)
		AZBar = CreateBar(azbar)

		local factionbar = {}
		factionbar.barcolor = {}
		factionbar.barcolor.r = RGBToDec(0)
		factionbar.barcolor.g = RGBToDec(255)
		factionbar.barcolor.b = RGBToDec(0)
		factionbar.barcolor.a = RGBToDec(255)
		FactionBar = CreateBar(factionbar)

		EPBar:Hide()
		AZBar:Hide()
		FactionBar:Hide()

		local spectext = {}
		spectext.w = TargetFrame:GetWidth()
		spectext.h = 20
		spectext.align = "TOPLEFT"
		spectext.text = ""
		spectext.textalign = "TOPLEFT"
		spectext.textsize = 10
		spectext.color = {}
		spectext.color.a = 0
		spectext.parent = TargetFrame
		spectext.x = 8
		spectext.y = -8
		spectext.autoresize = false
		TargetTalentText = createF(spectext)

		local spec = {}
		spec.w = 20
		spec.h = 20
		spec.align = "TOPRIGHT"
		spec.text = ""
		spec.textalign = "TOPRIGHT"
		spec.textsize = 13
		spec.color = {}
		spec.color.a = 0
		spec.parent = TargetFrame
		spec.x = -30
		spec.y = 0
		spec.autoresize = false
		TargetTalent = createF(spec)
		local tex = {}
		tex.texture = "fail"
		tex.parent = TargetTalent
		tex.frame = TargetTalent
		tex.layer = "ARTWORK"
		tex.color = {}
		tex.color.r = 1
		tex.color.g = 1
		tex.color.b = 1
		tex.color.a = 0
		if TargetTalent.specialization == nil then
			TargetTalent.specialization = CTexture(TargetTalent, tex)
		end

		--[[
		local abt = {}
		abt.align = "BOTTOM"
		abt.y = 36 + 8
		for i = 0, 11 do
			abt.x = 36 / 2 + (AB_BR / 2) + i * (36 + AB_BR)
			ABS[i] = CreateActionButton(abt)
		end
		]]
	end

	if D4HUDPC ~= nil and not dbloaded then
		dbloaded = true
		D4_HUD.InitSetting()

		D4_HUD.Lang_enEN()
		if GetLocale() == "deDE" then
			D4_HUD.msg("Language detected: deDE (Deutsch)")
			D4_HUD.Lang_deDE()
		end
		UpdateLanguage()
	end

	--[[
	for i = 0, 11 do
		ABS[i]:LoadAction()
	end
	]]

	-- HIDE
	StatusTrackingBarManager:Hide()
	MainMenuBarArtFrame.LeftEndCap:Hide()
	MainMenuBarArtFrame.RightEndCap:Hide()
	MainMenuBarArtFrameBackground:Hide()

	-- PlayerFrame
	--point, relativeTo, relativePoint, xOfs, yOfs = PlayerFrame:GetPoint();
	--print(point, relativeTo, relativePoint, xOfs, yOfs)
	--PlayerFrame:ClearAllPoints()
	--PlayerFrame:SetPoint("TOP", UIParent, "TOP", -PlayerFrame:GetWidth() / 2, -yOfs)
	-- TargetFrame
	--TargetFrame:ClearAllPoints()
	--TargetFrame:SetPoint("TOP", UIParent, "TOP", PlayerFrame:GetWidth() / 2, -TargetFrame:GetHeight())
	-- FocusFrame
	--FocusFrame:ClearAllPoints()
	--FocusFrame:SetPoint("CENTER", UIParent, "CENTER", PlayerFrame:GetWidth() * 1.5, 360)

	-- BOTTOM LEFT
	for i = 1, 12 do
		if _G["ActionButton" .. i] ~= nil then
			_G["ActionButton" .. i]:ClearAllPoints()
			_G["ActionButton" .. i]:SetPoint("BOTTOM", UIParent, "BOTTOM", (AB_W / 2) - (ABAR_W / 2) + (i - 1) * (AB_W + AB_BR), 2) -- -(ABAR_W / 2 - AB_W / 2) + (i - 1) * (AB_W + AB_BR), 2)
		end
	end
	-- TOP LEFT
	for i = 1, 12 do
		if _G["MultiBarBottomLeftButton" .. i] ~= nil then
			_G["MultiBarBottomLeftButton" .. i]:ClearAllPoints()
			_G["MultiBarBottomLeftButton" .. i]:SetPoint("BOTTOM", UIParent, "BOTTOM", (AB_W / 2 ) - (ABAR_W / 2) + (i - 1) * (AB_W + AB_BR), AB_W + 8) -- -(ABAR_W / 2 - AB_W / 2) + (i - 1) * (AB_W + AB_BR), AB_W + 8)
		end
	end
	-- Button Up and Down
	ActionBarUpButton:ClearAllPoints()
	ActionBarUpButton:SetPoint("BOTTOM", UIParent, "BOTTOM", -ABAR_W / 2 -ActionBarUpButton:GetWidth() + 3 + AB_BR, ActionBarUpButton:GetHeight())
	ActionBarDownButton:ClearAllPoints()
	ActionBarDownButton:SetPoint("BOTTOM", UIParent, "BOTTOM", -ABAR_W / 2 -ActionBarUpButton:GetWidth() + 3 + AB_BR, 0)

	MainMenuBarArtFrame.PageNumber:Hide()

	-- BOTTOM RIGHT
	MultiBarBottomRightButton1:ClearAllPoints()
	MultiBarBottomRightButton1:SetPoint("BOTTOM", UIParent, "BOTTOM", ABAR_W / 6 + AB_W / 2 + AB_BR, 2)
	-- TOP RIGHT
	MultiBarBottomRightButton7:ClearAllPoints()
	MultiBarBottomRightButton7:SetPoint("BOTTOM", UIParent, "BOTTOM", ABAR_W / 6 + AB_W / 2 + AB_BR, AB_W + 8)

	-- StanceBar
	local sb = {}
	sb.count = 1
	sb.iw = StanceButton1:GetWidth()
	sb.w = sb.iw * 12 + AB_BR * (12 - 1)
	for i = 1, 12 do
		local available, _, _, _, _ = GetShapeshiftFormInfo(i)
		if available then
			sb.count = i
		end
		if _G["StanceButton" .. i] ~= nil then
			_G["StanceButton" .. i]:ClearAllPoints()
			_G["StanceButton" .. i]:SetPoint("BOTTOM", UIParent, "BOTTOM", -sb.w / 2 + sb.iw / 2 + (i - 1) * (sb.iw + AB_BR), 86)
		end
	end
	sb.w = sb.iw * sb.count + AB_BR * (sb.count - 1)
	for i = 1, sb.count do
		_G["StanceButton" .. i]:ClearAllPoints()
		_G["StanceButton" .. i]:SetPoint("BOTTOM", UIParent, "BOTTOM", -sb.w / 2 + sb.iw / 2 + (i - 1) * (sb.iw + AB_BR), 86)
	end

	-- MainMenuBarVehicleLeaveButton
	MainMenuBarVehicleLeaveButton:ClearAllPoints()
	MainMenuBarVehicleLeaveButton:SetPoint("BOTTOM", UIParent, "BOTTOM", -ABAR_W / 2 + MainMenuBarVehicleLeaveButton:GetWidth() / 2, 86)

	-- ExtraActionButton
	ExtraActionButton1:ClearAllPoints()
	ExtraActionButton1:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 200)

	-- Micro
	MicroButtonAndBagsBar:ClearAllPoints()
	MicroButtonAndBagsBar:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 6, -4)
	for i, mb in pairs(MICRO_BUTTONS) do
		_G[mb]:ClearAllPoints()
		local size = 22
		_G[mb]:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 2 -#MICRO_BUTTONS * size + size * i, -2)
	end

	-- Bags
	local bigbagscale = 0.8
	MainMenuBarBackpackButton:SetScale(bigbagscale)
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, 40)
	for i = 0, 3 do
		_G["CharacterBag" .. i .. "Slot"]:ClearAllPoints()
		_G["CharacterBag" .. i .. "Slot"]:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -(MainMenuBarBackpackButton:GetWidth() * bigbagscale + _G["CharacterBag" .. i .. "Slot"]:GetWidth() * i), 33)
	end

	-- PetActionBar
	local pa = {}
	pa.count = 10
	pa.iw = PetActionButton1:GetWidth()
	pa.w = pa.iw * pa.count + AB_BR * (pa.count - 1)
	for i = 1, pa.count do
		_G["PetActionButton" .. i]:ClearAllPoints()
		_G["PetActionButton" .. i]:SetPoint("BOTTOM", UIParent, "BOTTOM", -pa.w / 2 + pa.iw / 2 + (i - 1) * (pa.iw + AB_BR), 86)
	end

	-- PossessBar
	local po = {}
	po.count = 10
	po.iw = PossessButton1:GetWidth()
	po.w = po.iw * po.count + AB_BR * (po.count - 1)
	for i = 1, po.count do
		if _G["PossessButton" .. i] ~= nil then
			_G["PossessButton" .. i]:ClearAllPoints()
			_G["PossessButton" .. i]:SetPoint("BOTTOM", UIParent, "BOTTOM", -po.iw / 2 + (i - 1) * (po.iw + AB_BR) - 380, 86)
			_G["PossessBackground" .. i]:Hide()
		end
	end

	PageNumber:SetText(GetActionBarPage())
end
hooksecurefunc("MultiActionBar_Update", Setup)

function Think()
	--[[
	for i = 0, 11 do
		ABS[i]:LoadAction()
	end
	]]

	-- TargetTalents
	if TargetTalent.player ~= UnitName("target") then
		TargetTalent.player = UnitName("target")
		TargetTalent.specialization:SetVertexColor(1, 1, 1, 0)
		TargetTalentText:SetText("")
	end

	if CanInspect("target", true) then
		local currentSpec = GetInspectSpecialization("target")
		if currentSpec ~= nil then
			local id, name, _, icon, _, _ = GetSpecializationInfoByID(currentSpec)
			if id ~= nil then
				TargetTalent.specialization:SetTexture(icon)
				TargetTalent.specialization:SetVertexColor(1, 1, 1, 1)
				TargetTalentText:SetText(name)
			end
		end
	end

	local Y = 0
	local LEVEL = UnitLevel("player")
	local LEVELMAX = GetMaxLevel()
	if GetConfig("EPBar") and LEVEL < LEVELMAX then
		EPBar:Show()
		local EP = UnitXP("player")
		local EPMax = UnitXPMax("player")
		local EPDec = EP / EPMax
		local EPPerc = tonumber(string.format("%.2f", EPDec * 100))
		local EPW = EPBar.background:GetWidth() * EPDec + 0.0001

		local EPExhaustion = GetXPExhaustion()
		local EPExhaustionDec = 0
		local EPExhaustionPerc = 0
		local EPExhaustionW = 0
		local EPExhaustionOverflow = false
		if EPExhaustion ~= nil then
			EPExhaustionDec = EPExhaustion / EPMax
			EPExhaustionPerc = tonumber(string.format("%.2f", EPExhaustionDec * 100))
			EPExhaustionW = EPBar.background:GetWidth() * EPExhaustionDec
			EPExhaustionOverflow = false
			if EPW + EPExhaustionW > EPBar.background:GetWidth() then -- Wenn erholung zu lang
				EPExhaustionOverflow = true
				EPExhaustionW = EPBar.background:GetWidth() - EPW -- Bis anschlag
			end
		end

		-- EPBar
		local missing = {}
		missing["VALUE"] = BreakUpLargeNumbers(EPMax - EP)
		local EPText = "Level " .. LEVEL .. "/" .. LEVELMAX .. " | " .. XP .. ": " .. BreakUpLargeNumbers(EP) .. "/" .. BreakUpLargeNumbers(EPMax) .. " (" .. EPPerc .. "%) (" .. D4_HUD.GT("xmissing", missing) .. ")"
		if EPExhaustion ~= nil and EPExhaustion > 0 then
			EPText = EPText .. " " .. TUTORIAL_TITLE26 .. ": " .. BreakUpLargeNumbers(EPExhaustion)
			if EPExhaustionOverflow then
				EPText = EPText .. "*"
			end
			EPText = EPText .. " (" .. EPExhaustionPerc .. "%)"
		end
		EPBar.bar:SetWidth(EPW)
		EPBar.overlay:SetText(EPText)
		EPBar.exhaustion:SetWidth(EPExhaustionW)

		EPBar.background:ClearAllPoints()
		EPBar.background:SetPoint("TOP", UIParent, "TOP", 0, -Y)
		EPBar.bar:ClearAllPoints()
		EPBar.bar:SetPoint("LEFT", EPBar.background, "LEFT", 0, -Y)
		EPBar.exhaustion:ClearAllPoints()
		EPBar.exhaustion:SetPoint("LEFT", EPBar.background, "LEFT", EPBar.background:GetWidth() * EPDec, -Y)

		Y = Y + EPBar.background:GetHeight()
	else
		EPBar:Hide()
	end

	local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem()
	if GetConfig("AZBar") and azeriteItemLocation then
		AZBar:Show()

		local AZEP, AZEPMax = C_AzeriteItem.GetAzeriteItemXPInfo(azeriteItemLocation)
		local AZEPDec = AZEP / AZEPMax
		local AZEPPerc = tonumber(string.format("%.2f", AZEPDec * 100))
		local AZEPToNextLevel = AZEPMax - AZEP
		local AZEPLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation)

		-- AZBar
		local AZEPText = ARTIFACT_POWER .. ": " .. BreakUpLargeNumbers(AZEP) .. "/" .. BreakUpLargeNumbers(AZEPMax) .. " (" .. AZEPPerc .. "%) | " .. string.format(AZERITE_POWER_TOOLTIP_TITLE, AZEPLevel, BreakUpLargeNumbers(AZEPToNextLevel))
		AZBar.bar:SetWidth(AZBar.background:GetWidth() * AZEPDec + 0.0001)
		AZBar.overlay:SetText(AZEPText)
		AZBar.background:ClearAllPoints()
		AZBar.background:SetPoint("TOP", UIParent, "TOP", 0, -Y)

		Y = Y + AZBar.background:GetHeight()
	else
		AZBar:Hide()
	end

	local Faction, FactionStatus, min, max, value = GetWatchedFactionInfo()
	if GetConfig("FABar") and Faction then
		FactionBar:Show()

		FactionStatusID = FactionStatus
		FactionStatus = getglobal("FACTION_STANDING_LABEL" .. FactionStatus)
		FactionMin = min
		FactionMax = max - FactionMin
		FactionValue = value - FactionMin
		FactionDec = FactionValue / FactionMax
		FactionPerc = tonumber(string.format("%.2f", FactionDec * 100))
		FactionW = FactionBar.background:GetWidth() * FactionDec + 0.0001

		-- FactionBar
		local FactionText = Faction .. " (" .. FactionStatus .. ")"
		if FactionStatusID < 8 then
			local missing = {}
			missing["VALUE"] = BreakUpLargeNumbers(FactionMax - FactionValue)
			FactionText = FactionText .. " " .. BreakUpLargeNumbers(FactionValue) .. "/" .. BreakUpLargeNumbers(FactionMax) .. " (" .. FactionPerc .. "%) (" .. D4_HUD.GT("xmissing", missing) .. ")"
			FactionBar.bar:SetWidth(FactionW)
		else
			FactionBar.bar:SetWidth(FactionBar.background:GetWidth())
		end
		FactionBar.overlay:SetText(FactionText)
		FactionBar.background:ClearAllPoints()
		FactionBar.background:SetPoint("TOP", UIParent, "TOP", 0, -Y)

		local factioncolor = GetFactionColor(FactionStatusID)
		FactionBar.overlay.texture:SetVertexColor(factioncolor.r, factioncolor.g, factioncolor.b, 1)

		Y = Y + FactionBar.background:GetHeight()
	else
		FactionBar:Hide()
	end

	if PlayerPowerBarAlt then
		Y = Y + 20

		PlayerPowerBarAlt:ClearAllPoints()
		PlayerPowerBarAlt:SetPoint("TOP", UIParent, "TOP", 0, -Y)

		Y = Y + PlayerPowerBarAlt:GetHeight()
	end

	if PlayerPowerBarAltCounterBar then
		Y = Y + 20

		PlayerPowerBarAltCounterBar:ClearAllPoints()
		PlayerPowerBarAltCounterBar:SetPoint("TOP", UIParent, "TOP", 0, -Y)

		Y = Y + PlayerPowerBarAltCounterBar:GetHeight()
	end

	if UIWidgetTopCenterContainerFrame then
		Y = Y + 20

		UIWidgetTopCenterContainerFrame:ClearAllPoints()
		UIWidgetTopCenterContainerFrame:SetPoint("TOP", UIParent, "TOP", 0, -Y)

		Y = Y + UIWidgetTopCenterContainerFrame:GetHeight()
	end

	if UIErrorsFrame then
		Y = Y + 20

		UIErrorsFrame:ClearAllPoints()
		UIErrorsFrame:SetPoint("TOP", UIParent, "TOP", 0, -Y)

		Y = Y + UIErrorsFrame:GetHeight()
	end

	if GetConfig("Coords") then
		Coords:Show()
	else
		Coords:Hide()
	end

	if GetConfig("SpecializationText") then
		TargetTalentText:Show()
	else
		TargetTalentText:Hide()
	end
	if GetConfig("SpecializationIcon") then
		TargetTalent.specialization:Show()
	else
		TargetTalent.specialization:Hide()
	end

	MicroButtonAndBagsBar.MicroBagBar:Hide()
	if GetConfig("CharacterBag") then
		for i = 0, 3 do
			_G["CharacterBag" .. i .. "Slot"]:Show()
		end
	else
		for i = 0, 3 do
			_G["CharacterBag" .. i .. "Slot"]:Hide()
		end
	end
	if GetConfig("Backpack") then
		MainMenuBarBackpackButton:Show()
	else
		MainMenuBarBackpackButton:Hide()
	end

	if GetConfig("MicroButtons") then
		for i, mb in pairs(MICRO_BUTTONS) do
			_G[mb]:Show()
		end
	else
		for i, mb in pairs(MICRO_BUTTONS) do
			_G[mb]:Hide()
		end
	end
end
C_Timer.NewTicker(0.6, Think)

function Update_Coords()
	if C_Map ~= nil then
		local mapID = C_Map.GetBestMapForUnit("player")
		if mapID ~= nil then
			local mapPos = C_Map.GetPlayerMapPosition(mapID, "player")
			if mapPos ~= nil then
				local px, py = mapPos:GetXY()
				if px ~= nil and py ~= nil then
					px = math.round(px * 100, 1)
					py = math.round(py * 100, 1)
					Coords:SetText(px .. ", " .. py)
				end
			else
				Coords:SetText(lang.notavailable)
			end
		end
	end
end
C_Timer.NewTicker(0.6, Update_Coords)

local frame = CreateFrame("FRAME")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("UPDATE_BONUS_ACTIONBAR")
frame:RegisterEvent("UPDATE_VEHICLE_ACTIONBAR")
frame:RegisterEvent("UPDATE_OVERRIDE_ACTIONBAR")
frame:RegisterEvent("ACTIONBAR_PAGE_CHANGED")
frame:RegisterEvent("PET_BAR_UPDATE")
frame:RegisterEvent("UNIT_ENTERING_VEHICLE")
frame:RegisterEvent("UNIT_ENTERED_VEHICLE")
frame:RegisterEvent("UNIT_EXITING_VEHICLE")
frame:RegisterEvent("UNIT_EXITED_VEHICLE")
frame:RegisterEvent("PLAYER_GAINS_VEHICLE_DATA")
frame:RegisterEvent("UNIT_NAME_UPDATE");
frame:RegisterEvent("UNIT_DISPLAYPOWER");
frame:RegisterEvent("UNIT_PORTRAIT_UPDATE")
frame:RegisterEvent("PORTRAITS_UPDATED");
frame:RegisterEvent("UNIT_COMBAT")
frame:RegisterEvent("PLAYER_FLAGS_CHANGED")
frame:RegisterEvent("UNIT_CONNECTION")
frame:RegisterEvent("UNIT_PHASE")
frame:RegisterEvent("RAID_TARGET_UPDATE")
frame:RegisterEvent("GROUP_ROSTER_UPDATE")
frame:RegisterEvent("PARTY_LEADER_CHANGED")
frame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
frame:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
frame:RegisterEvent("UNIT_FACTION")
frame:RegisterEvent("UNIT_FLAGS")
frame:RegisterEvent("UNIT_CLASSIFICATION_CHANGED")
frame:RegisterEvent("UNIT_AURA")
frame:RegisterEvent("UNIT_HEALTH_FREQUENT")
frame:RegisterEvent("PET_BATTLE_HEALTH_CHANGED")
frame:RegisterEvent("UPDATE_SUMMONPETS_ACTION")
frame:RegisterEvent("UNIT_POWER_FREQUENT")
frame:RegisterEvent("UNIT_MAXPOWER")
frame:RegisterEvent("UNIT_MAXHEALTH")
frame:RegisterEvent("UNIT_LEVEL")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_ALIVE")
local function eventHandler(self, event, ...)
	Setup()
end
frame:SetScript("OnEvent", eventHandler)

print("|c0000ffffLoaded |c008888ff" .. D4_HUD.name .. "|c0000ffff by |c008888ff" .. D4_HUD.author .. "|c0000ffff!")
